# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from clearpath_platform_msgs/Power.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg

class Power(genpy.Message):
  _md5sum = "e70a487002e4f8605397497e1c0404c3"
  _type = "clearpath_platform_msgs/Power"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# Robot Power readings

std_msgs/Header header

# AC Power
int8 NOT_APPLICABLE=-1

int8 shore_power_connected  # Indicates if AC power is connected.
int8 battery_connected      # Indicates if battery is connected.
int8 power_12v_user_nominal # Indicates if the 12V user power is good.
int8 charging_complete      # Indicates if charging is complete.

# Voltage rails, in volts
# Averaged over the message period

# Jackal
uint8 JACKAL_MEASURED_BATTERY=0
uint8 JACKAL_MEASURED_5V=1
uint8 JACKAL_MEASURED_12V=2

# Dingo
uint8 DINGO_MEASURED_BATTERY=0
uint8 DINGO_MEASURED_5V=1
uint8 DINGO_MEASURED_12V=2

# Warthog
uint8 WARTHOG_MEASURED_BATTERY=0
uint8 WARTHOG_MEASURED_12V=1
uint8 WARTHOG_MEASURED_24V=2
uint8 WARTHOG_MEASURED_48V=3

# Ridgeback
uint8 RIDGEBACK_MEASURED_BATTERY=0
uint8 RIDGEBACK_MEASURED_5V=1
uint8 RIDGEBACK_MEASURED_12V=2
uint8 RIDGEBACK_MEASURED_INVERTER=3
uint8 RIDGEBACK_MEASURED_FRONT_AXLE=4
uint8 RIDGEBACK_MEASURED_REAR_AXLE=5
uint8 RIDGEBACK_MEASURED_LIGHT=6

float32[] measured_voltages

# Current senses available on platform, in amps.
# Averaged over the message period

# Jackal
uint8 JACKAL_TOTAL_CURRENT=0
uint8 JACKAL_COMPUTER_CURRENT=1
uint8 JACKAL_DRIVE_CURRENT=2
uint8 JACKAL_USER_CURRENT=3

# Dingo
uint8 DINGO_TOTAL_CURRENT=0
uint8 DINGO_COMPUTER_CURRENT=1

# Warthog
uint8 WARTHOG_TOTAL_CURRENT=0
uint8 WARTHOG_COMPUTER_CURRENT=1
uint8 WARTHOG_12V_CURRENT=2
uint8 WARTHOG_24V_CURRENT=3
uint8 WARTHOG_48V_CURRENT=4

# Ridgeback
uint8 RIDGEBACK_TOTAL_CURRENT=0

float32[] measured_currents

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id
"""
  # Pseudo-constants
  NOT_APPLICABLE = -1
  JACKAL_MEASURED_BATTERY = 0
  JACKAL_MEASURED_5V = 1
  JACKAL_MEASURED_12V = 2
  DINGO_MEASURED_BATTERY = 0
  DINGO_MEASURED_5V = 1
  DINGO_MEASURED_12V = 2
  WARTHOG_MEASURED_BATTERY = 0
  WARTHOG_MEASURED_12V = 1
  WARTHOG_MEASURED_24V = 2
  WARTHOG_MEASURED_48V = 3
  RIDGEBACK_MEASURED_BATTERY = 0
  RIDGEBACK_MEASURED_5V = 1
  RIDGEBACK_MEASURED_12V = 2
  RIDGEBACK_MEASURED_INVERTER = 3
  RIDGEBACK_MEASURED_FRONT_AXLE = 4
  RIDGEBACK_MEASURED_REAR_AXLE = 5
  RIDGEBACK_MEASURED_LIGHT = 6
  JACKAL_TOTAL_CURRENT = 0
  JACKAL_COMPUTER_CURRENT = 1
  JACKAL_DRIVE_CURRENT = 2
  JACKAL_USER_CURRENT = 3
  DINGO_TOTAL_CURRENT = 0
  DINGO_COMPUTER_CURRENT = 1
  WARTHOG_TOTAL_CURRENT = 0
  WARTHOG_COMPUTER_CURRENT = 1
  WARTHOG_12V_CURRENT = 2
  WARTHOG_24V_CURRENT = 3
  WARTHOG_48V_CURRENT = 4
  RIDGEBACK_TOTAL_CURRENT = 0

  __slots__ = ['header','shore_power_connected','battery_connected','power_12v_user_nominal','charging_complete','measured_voltages','measured_currents']
  _slot_types = ['std_msgs/Header','int8','int8','int8','int8','float32[]','float32[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,shore_power_connected,battery_connected,power_12v_user_nominal,charging_complete,measured_voltages,measured_currents

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Power, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.shore_power_connected is None:
        self.shore_power_connected = 0
      if self.battery_connected is None:
        self.battery_connected = 0
      if self.power_12v_user_nominal is None:
        self.power_12v_user_nominal = 0
      if self.charging_complete is None:
        self.charging_complete = 0
      if self.measured_voltages is None:
        self.measured_voltages = []
      if self.measured_currents is None:
        self.measured_currents = []
    else:
      self.header = std_msgs.msg.Header()
      self.shore_power_connected = 0
      self.battery_connected = 0
      self.power_12v_user_nominal = 0
      self.charging_complete = 0
      self.measured_voltages = []
      self.measured_currents = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_4b().pack(_x.shore_power_connected, _x.battery_connected, _x.power_12v_user_nominal, _x.charging_complete))
      length = len(self.measured_voltages)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.Struct(pattern).pack(*self.measured_voltages))
      length = len(self.measured_currents)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.Struct(pattern).pack(*self.measured_currents))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 4
      (_x.shore_power_connected, _x.battery_connected, _x.power_12v_user_nominal, _x.charging_complete,) = _get_struct_4b().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.measured_voltages = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.measured_currents = s.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_4b().pack(_x.shore_power_connected, _x.battery_connected, _x.power_12v_user_nominal, _x.charging_complete))
      length = len(self.measured_voltages)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.measured_voltages.tostring())
      length = len(self.measured_currents)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.measured_currents.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 4
      (_x.shore_power_connected, _x.battery_connected, _x.power_12v_user_nominal, _x.charging_complete,) = _get_struct_4b().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.measured_voltages = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.measured_currents = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_4b = None
def _get_struct_4b():
    global _struct_4b
    if _struct_4b is None:
        _struct_4b = struct.Struct("<4b")
    return _struct_4b
