# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from clearpath_platform_msgs/StackLightState.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import clearpath_platform_msgs.msg

class StackLightState(genpy.Message):
  _md5sum = "2a13a70eec85367ac172357e72bdf1c6"
  _type = "clearpath_platform_msgs/StackLightState"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Status messages can be encoded with the LEDs on the stack light
# The light has 2 componenents: a 3-channel RYG LED and an orange strobe

# What is the RYG color of the stack light?
RYG color

# Is the strobe light currently on?
bool strobe_on

# Human-readable explanation of why the light is in the state it's in
string message

================================================================================
MSG: clearpath_platform_msgs/RYG
# Represents the intensity of a single RYG LED, either reported or commanded.
# Each channel is limited to a range of [0, 255]

uint8 red
uint8 yellow
uint8 green
"""
  __slots__ = ['color','strobe_on','message']
  _slot_types = ['clearpath_platform_msgs/RYG','bool','string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       color,strobe_on,message

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(StackLightState, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.color is None:
        self.color = clearpath_platform_msgs.msg.RYG()
      if self.strobe_on is None:
        self.strobe_on = False
      if self.message is None:
        self.message = ''
    else:
      self.color = clearpath_platform_msgs.msg.RYG()
      self.strobe_on = False
      self.message = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_4B().pack(_x.color.red, _x.color.yellow, _x.color.green, _x.strobe_on))
      _x = self.message
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.color is None:
        self.color = clearpath_platform_msgs.msg.RYG()
      end = 0
      _x = self
      start = end
      end += 4
      (_x.color.red, _x.color.yellow, _x.color.green, _x.strobe_on,) = _get_struct_4B().unpack(str[start:end])
      self.strobe_on = bool(self.strobe_on)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.message = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.message = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_4B().pack(_x.color.red, _x.color.yellow, _x.color.green, _x.strobe_on))
      _x = self.message
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.color is None:
        self.color = clearpath_platform_msgs.msg.RYG()
      end = 0
      _x = self
      start = end
      end += 4
      (_x.color.red, _x.color.yellow, _x.color.green, _x.strobe_on,) = _get_struct_4B().unpack(str[start:end])
      self.strobe_on = bool(self.strobe_on)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.message = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.message = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_4B = None
def _get_struct_4B():
    global _struct_4B
    if _struct_4B is None:
        _struct_4B = struct.Struct("<4B")
    return _struct_4B
