# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from clearpath_platform_msgs/Status.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy
import std_msgs.msg

class Status(genpy.Message):
  _md5sum = "1f0a1e0c4d6171b053e50dc562ba0a37"
  _type = "clearpath_platform_msgs/Status"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# This message represents lower-frequency status updates
# Default publish frequency is 1Hz.

std_msgs/Header header

# Robot Hardware ID
string hardware_id

# Firmware commit hash
string firmware_commit

# Times since MCU power-on.
std_msgs/Duration mcu_uptime
std_msgs/Duration connection_uptime

# Temperature of MCU's PCB in Celsius.
float32 pcb_temperature
float32 mcu_temperature

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: std_msgs/Duration
duration data
"""
  __slots__ = ['header','hardware_id','firmware_commit','mcu_uptime','connection_uptime','pcb_temperature','mcu_temperature']
  _slot_types = ['std_msgs/Header','string','string','std_msgs/Duration','std_msgs/Duration','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,hardware_id,firmware_commit,mcu_uptime,connection_uptime,pcb_temperature,mcu_temperature

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Status, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.hardware_id is None:
        self.hardware_id = ''
      if self.firmware_commit is None:
        self.firmware_commit = ''
      if self.mcu_uptime is None:
        self.mcu_uptime = std_msgs.msg.Duration()
      if self.connection_uptime is None:
        self.connection_uptime = std_msgs.msg.Duration()
      if self.pcb_temperature is None:
        self.pcb_temperature = 0.
      if self.mcu_temperature is None:
        self.mcu_temperature = 0.
    else:
      self.header = std_msgs.msg.Header()
      self.hardware_id = ''
      self.firmware_commit = ''
      self.mcu_uptime = std_msgs.msg.Duration()
      self.connection_uptime = std_msgs.msg.Duration()
      self.pcb_temperature = 0.
      self.mcu_temperature = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.hardware_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.firmware_commit
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_4i2f().pack(_x.mcu_uptime.data.secs, _x.mcu_uptime.data.nsecs, _x.connection_uptime.data.secs, _x.connection_uptime.data.nsecs, _x.pcb_temperature, _x.mcu_temperature))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.mcu_uptime is None:
        self.mcu_uptime = std_msgs.msg.Duration()
      if self.connection_uptime is None:
        self.connection_uptime = std_msgs.msg.Duration()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.hardware_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.hardware_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.firmware_commit = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.firmware_commit = str[start:end]
      _x = self
      start = end
      end += 24
      (_x.mcu_uptime.data.secs, _x.mcu_uptime.data.nsecs, _x.connection_uptime.data.secs, _x.connection_uptime.data.nsecs, _x.pcb_temperature, _x.mcu_temperature,) = _get_struct_4i2f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.hardware_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.firmware_commit
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_4i2f().pack(_x.mcu_uptime.data.secs, _x.mcu_uptime.data.nsecs, _x.connection_uptime.data.secs, _x.connection_uptime.data.nsecs, _x.pcb_temperature, _x.mcu_temperature))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.mcu_uptime is None:
        self.mcu_uptime = std_msgs.msg.Duration()
      if self.connection_uptime is None:
        self.connection_uptime = std_msgs.msg.Duration()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.hardware_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.hardware_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.firmware_commit = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.firmware_commit = str[start:end]
      _x = self
      start = end
      end += 24
      (_x.mcu_uptime.data.secs, _x.mcu_uptime.data.nsecs, _x.connection_uptime.data.secs, _x.connection_uptime.data.nsecs, _x.pcb_temperature, _x.mcu_temperature,) = _get_struct_4i2f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_4i2f = None
def _get_struct_4i2f():
    global _struct_4i2f
    if _struct_4i2f is None:
        _struct_4i2f = struct.Struct("<4i2f")
    return _struct_4i2f
